From: Steven Rostedt <rostedt@goodmis.org>
To: linux-kernel@vger.kernel.org
Cc: Masami Hiramatsu <mhiramat@kernel.org>,
Mark Rutland <mark.rutland@arm.com>,
Mathieu Desnoyers <mathieu.desnoyers@efficios.com>,
Andrew Morton <akpm@linux-foundation.org>,
Alexei Starovoitov <alexei.starovoitov@gmail.com>,
Florent Revest <revest@chromium.org>,
Martin KaFai Lau <martin.lau@linux.dev>,
bpf <bpf@vger.kernel.org>, Sven Schnelle <svens@linux.ibm.com>,
Alexei Starovoitov <ast@kernel.org>, Jiri Olsa <jolsa@kernel.org>,
Arnaldo Carvalho de Melo <acme@kernel.org>,
Daniel Borkmann <daniel@iogearbox.net>,
Alan Maguire <alan.maguire@oracle.com>,
Peter Zijlstra <peterz@infradead.org>,
Thomas Gleixner <tglx@linutronix.de>, Guo Ren <guoren@kernel.org>
Subject: [for-next][PATCH 27/27] selftests/ftrace: Add fgraph-multi.tc test
Date: Tue, 04 Jun 2024 10:41:30 -0400 [thread overview]
Message-ID: <20240604144218.325348498@goodmis.org> (raw)
In-Reply-To: 20240604144103.293353991@goodmis.org
From: "Steven Rostedt (Google)" <rostedt@goodmis.org>
Add a test that creates 3 instances and enables function_graph tracer in
each as well as the top instance, where each will enable a filter (but one
that traces all functions) and check that they are filtering properly.
Link: https://lore.kernel.org/linux-trace-kernel/20240603190825.252845939@goodmis.org
Cc: Masami Hiramatsu <mhiramat@kernel.org>
Cc: Mark Rutland <mark.rutland@arm.com>
Cc: Mathieu Desnoyers <mathieu.desnoyers@efficios.com>
Cc: Andrew Morton <akpm@linux-foundation.org>
Cc: Alexei Starovoitov <alexei.starovoitov@gmail.com>
Cc: Florent Revest <revest@chromium.org>
Cc: Martin KaFai Lau <martin.lau@linux.dev>
Cc: bpf <bpf@vger.kernel.org>
Cc: Sven Schnelle <svens@linux.ibm.com>
Cc: Alexei Starovoitov <ast@kernel.org>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Arnaldo Carvalho de Melo <acme@kernel.org>
Cc: Daniel Borkmann <daniel@iogearbox.net>
Cc: Alan Maguire <alan.maguire@oracle.com>
Cc: Peter Zijlstra <peterz@infradead.org>
Cc: Thomas Gleixner <tglx@linutronix.de>
Cc: Guo Ren <guoren@kernel.org>
Reviewed-by: Masami Hiramatsu (Google) <mhiramat@kernel.org>
Signed-off-by: Steven Rostedt (Google) <rostedt@goodmis.org>
---
.../ftrace/test.d/ftrace/fgraph-multi.tc | 103 ++++++++++++++++++
1 file changed, 103 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/ftrace/fgraph-multi.tc
diff --git a/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-multi.tc b/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-multi.tc
new file mode 100644
index 000000000000..ff88f97e41fb
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/ftrace/fgraph-multi.tc
@@ -0,0 +1,103 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: ftrace - function graph filters
+# requires: set_ftrace_filter function_graph:tracer
+
+# Make sure that function graph filtering works
+
+INSTANCE1="instances/test1_$$"
+INSTANCE2="instances/test2_$$"
+INSTANCE3="instances/test3_$$"
+
+WD=`pwd`
+
+do_reset() {
+ cd $WD
+ if [ -d $INSTANCE1 ]; then
+ echo nop > $INSTANCE1/current_tracer
+ rmdir $INSTANCE1
+ fi
+ if [ -d $INSTANCE2 ]; then
+ echo nop > $INSTANCE2/current_tracer
+ rmdir $INSTANCE2
+ fi
+ if [ -d $INSTANCE3 ]; then
+ echo nop > $INSTANCE3/current_tracer
+ rmdir $INSTANCE3
+ fi
+}
+
+mkdir $INSTANCE1
+if ! grep -q function_graph $INSTANCE1/available_tracers; then
+ echo "function_graph not allowed with instances"
+ rmdir $INSTANCE1
+ exit_unsupported
+fi
+
+mkdir $INSTANCE2
+mkdir $INSTANCE3
+
+fail() { # msg
+ do_reset
+ echo $1
+ exit_fail
+}
+
+disable_tracing
+clear_trace
+
+do_test() {
+ REGEX=$1
+ TEST=$2
+
+ # filter something, schedule is always good
+ if ! echo "$REGEX" > set_ftrace_filter; then
+ fail "can not enable filter $REGEX"
+ fi
+
+ echo > trace
+ echo function_graph > current_tracer
+ enable_tracing
+ sleep 1
+ # search for functions (has "{" or ";" on the line)
+ echo 0 > tracing_on
+ count=`cat trace | grep -v '^#' | grep -e '{' -e ';' | grep -v "$TEST" | wc -l`
+ echo 1 > tracing_on
+ if [ $count -ne 0 ]; then
+ fail "Graph filtering not working by itself against $TEST?"
+ fi
+
+ # Make sure we did find something
+ echo 0 > tracing_on
+ count=`cat trace | grep -v '^#' | grep -e '{' -e ';' | grep "$TEST" | wc -l`
+ echo 1 > tracing_on
+ if [ $count -eq 0 ]; then
+ fail "No traces found with $TEST?"
+ fi
+}
+
+do_test '*sched*' 'sched'
+cd $INSTANCE1
+do_test '*lock*' 'lock'
+cd $WD
+cd $INSTANCE2
+do_test '*rcu*' 'rcu'
+cd $WD
+cd $INSTANCE3
+echo function_graph > current_tracer
+
+sleep 1
+count=`cat trace | grep -v '^#' | grep -e '{' -e ';' | grep "$TEST" | wc -l`
+if [ $count -eq 0 ]; then
+ fail "No traces found with all tracing?"
+fi
+
+cd $WD
+echo nop > current_tracer
+echo nop > $INSTANCE1/current_tracer
+echo nop > $INSTANCE2/current_tracer
+echo nop > $INSTANCE3/current_tracer
+
+do_reset
+
+exit 0
--
2.43.0
prev parent reply other threads:[~2024-06-04 14:42 UTC|newest]
Thread overview: 28+ messages / expand[flat|nested] mbox.gz Atom feed top
2024-06-04 14:41 [for-next][PATCH 00/27] function_graph: Allow multiple users for v6.11 Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 01/27] function_graph: Convert ret_stack to a series of longs Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 02/27] fgraph: Use BUILD_BUG_ON() to make sure we have structures divisible by long Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 03/27] function_graph: Add an array structure that will allow multiple callbacks Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 04/27] function_graph: Allow multiple users to attach to function graph Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 05/27] function_graph: Handle tail calls for stack unwinding Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 06/27] function_graph: Remove logic around ftrace_graph_entry and return Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 07/27] ftrace/function_graph: Pass fgraph_ops to function graph callbacks Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 08/27] ftrace: Allow function_graph tracer to be enabled in instances Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 09/27] ftrace: Allow ftrace startup flags to exist without dynamic ftrace Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 10/27] ftrace: Add subops logic to allow one ops to manage many Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 11/27] ftrace: Allow subops filtering to be modified Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 12/27] function_graph: Have the instances use their own ftrace_ops for filtering Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 13/27] function_graph: Add pid tracing back to function graph tracer Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 14/27] function_graph: Use a simple LRU for fgraph_array index number Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 15/27] function_graph: Add "task variables" per task for fgraph_ops Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 16/27] function_graph: Move set_graph_function tests to shadow stack global var Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 17/27] function_graph: Move graph depth stored data " Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 18/27] function_graph: Move graph notrace bit " Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 19/27] function_graph: Implement fgraph_reserve_data() and fgraph_retrieve_data() Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 20/27] function_graph: Add selftest for passing local variables Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 21/27] ftrace: Add multiple fgraph storage selftest Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 22/27] function_graph: Use for_each_set_bit() in __ftrace_return_to_handler() Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 23/27] function_graph: Use bitmask to loop on fgraph entry Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 24/27] function_graph: Use static_call and branch to optimize entry function Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 25/27] function_graph: Use static_call and branch to optimize return function Steven Rostedt
2024-06-04 14:41 ` [for-next][PATCH 26/27] selftests/ftrace: Add function_graph tracer to func-filter-pid test Steven Rostedt
2024-06-04 14:41 ` Steven Rostedt [this message]
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20240604144218.325348498@goodmis.org \
--to=rostedt@goodmis.org \
--cc=acme@kernel.org \
--cc=akpm@linux-foundation.org \
--cc=alan.maguire@oracle.com \
--cc=alexei.starovoitov@gmail.com \
--cc=ast@kernel.org \
--cc=bpf@vger.kernel.org \
--cc=daniel@iogearbox.net \
--cc=guoren@kernel.org \
--cc=jolsa@kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=mark.rutland@arm.com \
--cc=martin.lau@linux.dev \
--cc=mathieu.desnoyers@efficios.com \
--cc=mhiramat@kernel.org \
--cc=peterz@infradead.org \
--cc=revest@chromium.org \
--cc=svens@linux.ibm.com \
--cc=tglx@linutronix.de \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.